package com.xyzc.start.domain;

import com.baomidou.mybatisplus.annotation.*;
import com.xyzc.common.mybatis.core.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serial;

/**
 * 图片处理基本模板对象 xy_comfyui_workflow
 *
 * @author yz
 * @date 2024-08-08
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("xy_comfyui_workflow")
public class ComfyuiWorkflow extends BaseEntity {

    @Serial
    private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId(value = "id")
    private Long id;

    /**
     * ComfyUI配置的任务流程模板的json，用于生成图片的配置
     */
    private String workflowJson;

    /**
     * 序号
     */
    private Integer sort;

    /**
     * 类型：1:图片抠图；2:换背景
     */
    private Integer picType;

    /**
     * 例图地址
     */
    private String picUrl;

    /**
     * 图片名称
     */
    private String picName;

    /**
     * key用于ComfyUI校验
     */
    private String appKey;


}
