package com.xyzc.start.domain;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.xyzc.common.mybatis.core.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;

import java.io.Serial;

/**
 * 数字人提交训练对象 xy_np_commit_train
 *
 * @author wyz
 * @date 2024-08-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
@JsonInclude(JsonInclude.Include.NON_NULL)
@TableName("xy_np_commit_train")
public class NpCommitTrain extends BaseEntity {

    @Serial
    private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId(value = "id")
    private Long id;

    /**
     * 模型id
     */
    private Integer modelId;

    /**
     * 数字人名称
     */
    private String name;

    /**
     * 训练视频url，需公网可访问
     */
    private String videoUrl;

    /**
     * 训练状态回调地址
训练状态回调地址
     */
    private String callbackUrl;

    /**
     * 定制套餐级别： 空或2.形象克隆-高阶版 358.形象克隆-S级-超清 359.形象克隆-E级 360.形象克隆-S级
     */
    private Integer level;

    /**
     * 是否是绿幕: 0.否 1.是
     */
    private Integer greenScreen;

//    /**
//     * ID
//     */
//    private Integer trainingId;

    /**
     * 标题
     */
    private String title;

    /**
     * 训练状态 0或空-准备中 1训练中 2训练成功 3训练失败 4审核不通过
     */
    private Integer status;

    /**
     * 回调状态 0或空-初始态 1-回调成功 2-回调失败

     */
    private Integer callbackStatus;

    /**
     * 备注
     */
    private String comment;

    /**
     * 训练完成模特ID
     */
    private Integer robotId;

    /**
     * 训练完成场景ID
     */
    private Integer sceneId;

    /**
     * 模特封面地址
     */
    private String coverUrl;

    /**
     * 训练创建时间
     */
    private String trainCreateTime;

    /**
     * 训练更新时间
     */
    private String trainUpdateTime;

    /**
     * 训练完成后的模特详情
     */
    private String robotJson;

    /**
     * 场景名称
     */
    private String sceneName;

    /**
     * 示例视频
     */
    private String exampleUrl;

    /**
     * 示例图片
     */
    private String samplePictureUrl;

    /**
     * 基础用户
     */
    private String baseUserId;

    /*
    默认适配的tts发言人
     */
    private String speakerId;

    /**
     * 删除标记
     */
    private String delFlag;


}
