package com.xyzc.start.domain;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.xyzc.common.mybatis.core.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serial;

/**
 * 模板信息对象 xy_np_formwork
 *
 * @author wyz
 * @date 2024-08-23
 */
@Data
@EqualsAndHashCode(callSuper = true)
@JsonInclude(JsonInclude.Include.NON_NULL)
@TableName("xy_np_formwork")
public class NpFormwork extends BaseEntity {

    @Serial
    private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId(value = "id")
    private Long id;

    /**
     * 基础用户
     */
    private Long baseUserId;

    /**
     * 模板元素
     */
    private String nodes;

    /**
     * 名称
     */
    private String name;

    /**
     * 模板类型:1:我的；2:热门
     */
    private Integer type;

    /**
     * 1:竖版;2:横版
     */
    private Integer formworkType;


}
