package com.xyzc.start.domain;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xyzc.common.mybatis.core.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serial;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName("xy_config")
public class XyConfig extends BaseEntity {

    @Serial
    private static final long serialVersionUID = 1L;

    /**
     * 小易平台配置id
     */
    @TableId(value = "id")
    private Integer id;

    /**
     * 积分转换比例
     */
    private Integer integralTo;

    /**
     * 权益变更确认天数
     */
    private Integer equityChangeDate;

    /**
     * 积分剩余报警
     */
    private Long integralWarn;

    /**
     * 银行名称
     */
    private String bankName;

    /**
     * 开户银行
     */
    private String accountBankName;

    /**
     * 开户名
     */
    private String accountName;

    /**
     * 开户账号
     */
    private String bankAccountNumber;

    /**
     * 用户协议
     */
    private String userAgreement;

    /**
     * 隐私政策
     */
    private String secretPolicy;

    /**
     * 积分规则
     */
    private String integralRule;

    /**
     * 燃料规则
     */
    private String fuelRule;

    /**
     * 会员协议
     */
    private String memberAgreement;

    /**
     * 会员权益
     */
    private String memberEquity;

    /**
     * 数字人定制模型协议
     */
    private String digitalHumanCustomModelAgreement;

    /**
     * 数字人声音克隆协议
     */
    private String digitalHumanVoiceCloneAgreement;
}
