package com.xyzc.start.domain.bo;

import com.xyzc.common.core.validate.AddGroup;
import com.xyzc.common.core.validate.EditGroup;
import com.xyzc.start.domain.ComfyuiModel;
import io.github.linpeilie.annotations.AutoMapper;
import lombok.Data;
import jakarta.validation.constraints.*;

/**
 * comfyui模型业务对象 xy_comfyui_model
 *
 * @author wyz
 * @date 2024-08-08
 */
@Data
@AutoMapper(target = ComfyuiModel.class, reverseConvertGenerate = false)
public class ComfyuiModelBo {

    /**
     * 
     */
    @NotNull(message = "不能为空", groups = {EditGroup.class})
    private Integer id;

    /**
     * 工作流类型
     */
    @NotNull(message = "工作流类型不能为空", groups = {AddGroup.class, EditGroup.class})
    private Integer picType;

    /**
     * 工作流模型描述
     */
    @NotBlank(message = "工作流模型描述不能为空", groups = {AddGroup.class, EditGroup.class})
    private String picDesc;

    /**
     * 模型名称
     */
    @NotBlank(message = "模型名称不能为空", groups = {AddGroup.class, EditGroup.class})
    private String modelName;

    /**
     * 模型存放地址
     */
    @NotBlank(message = "模型存放地址不能为空", groups = {AddGroup.class, EditGroup.class})
    private String modelDir;

    /**
     * 备注
     */
    @NotBlank(message = "备注不能为空", groups = {AddGroup.class, EditGroup.class})
    private String remark;

}
