package com.xyzc.start.domain.bo;

import com.xyzc.common.core.validate.AddGroup;
import com.xyzc.common.core.validate.EditGroup;
import com.xyzc.start.domain.ComfyuiWorkflow;
import io.github.linpeilie.annotations.AutoMapper;
import lombok.Data;
import jakarta.validation.constraints.*;

/**
 * 图片处理基本模板业务对象 xy_comfyui_workflow
 *
 * @author wyz
 * @date 2024-08-08
 */
@Data
@AutoMapper(target = ComfyuiWorkflow.class, reverseConvertGenerate = false)
public class ComfyuiWorkflowBo {

    /**
     * 
     */
    @NotNull(message = "不能为空", groups = {EditGroup.class})
    private Long id;

    /**
     * ComfyUI配置的任务流程模板的json，用于生成图片的配置
     */
    @NotBlank(message = "ComfyUI配置的任务流程模板的json，用于生成图片的配置不能为空", groups = {AddGroup.class, EditGroup.class})
    private String workflowJson;

    /**
     * 序号
     */
    @NotNull(message = "序号不能为空", groups = {AddGroup.class, EditGroup.class})
    private Integer sort;

    /**
     * 类型：1:图片抠图；2:换背景
     */
    @NotNull(message = "类型：1:图片抠图；2:换背景不能为空", groups = {AddGroup.class, EditGroup.class})
    private Integer picType;

    /**
     * 例图地址
     */
    @NotBlank(message = "例图地址不能为空", groups = {AddGroup.class, EditGroup.class})
    private String picUrl;

    /**
     * 图片名称
     */
    @NotBlank(message = "图片名称不能为空", groups = {AddGroup.class, EditGroup.class})
    private String picName;

    /**
     * key用于ComfyUI校验
     */
    @NotBlank(message = "key用于ComfyUI校验不能为空", groups = {AddGroup.class, EditGroup.class})
    private String appKey;

}
