package com.xyzc.start.domain.bo;


import com.xyzc.common.core.validate.AddGroup;
import com.xyzc.common.core.xss.Xss;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotEmpty;
import lombok.Data;
import lombok.RequiredArgsConstructor;
import org.hibernate.validator.constraints.Range;

@Data
@RequiredArgsConstructor
public class HelpFeedbackBo {

    /**
     * 反馈内容
     */
    @Xss(message = "用户反馈不能包含脚本字符", groups = AddGroup.class)
    @NotBlank(message = "反馈内容不能为空")
    private String content;

    /**
     * 反馈类型；1-用户反馈；2-绘画模型反馈
     */
    @Range(min = 1, max = 2, message = "反馈类型不合法")
    @NotBlank(message = "反馈类型不能为空")
    private Integer feedbackType;

}
