package com.xyzc.start.domain.vo;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.xyzc.start.domain.XyConfig;
import io.github.linpeilie.annotations.AutoMapper;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;


/**
 * 小易平台配置视图对象 xy_config
 *
 * @author yz
 * @date 2024-07-05
 */
@Data
@AutoMapper(target = XyConfig.class)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class XyConfigVo implements Serializable {

    @Serial
    private static final long serialVersionUID = 1L;

    /**
     * 小易平台配置id
     */
    private Integer id;

    /**
     * 积分转换比例
     */
    private Integer integralTo;

    /**
     * 权益变更确认天数
     */

    private Integer equityChangeDate;

    /**
     * 积分剩余报警
     */

    private Long integralWarn;

    /**
     * 转账银行
     */
    private String bankName;

    /**
     * 开户银行
     */
    private String accountBankName;

    /**
     * 开户名
     */
    private String accountName;

    /**
     * 开户账号
     */
    private String bankAccountNumber;

    /**
     * 用户协议
     */
    private String userAgreement;

    /**
     * 隐私政策
     */
    private String secretPolicy;

    /**
     * 积分规则
     */
    private String integralRule;

    /**
     * 燃料规则
     */
    private String fuelRule;

    /**
     * 会员协议
     */
    private String memberAgreement;

    /**
     * 会员权益
     */
    private String memberEquity;

    /**
     * 数字人定制模型协议
     */
    private String digitalHumanCustomModelAgreement;

    /**
     * 数字人声音克隆协议
     */
    private String digitalHumanVoiceCloneAgreement;
}
