package com.xyzc.start.service.impl;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xyzc.common.core.exception.ErrorCode;
import com.xyzc.common.core.exception.ServerException;
import com.xyzc.common.web.security.user.SecurityUser;
import com.xyzc.start.domain.*;
import com.xyzc.start.mapper.*;
import com.xyzc.start.service.INpCommitService;
import com.xyzc.start.service.INpQueryService;
import com.xyzc.start.utils.SnowflakeIdWorker;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.logging.log4j.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.security.NoSuchAlgorithmException;
import java.util.*;

@Service
@RequiredArgsConstructor
@Slf4j
public class NpQueryServiceImpl implements INpQueryService {

    // 基本URL请求
    String baseUrl = "https://meta.guiji.ai";


//    String appKey = "IyeVRCSyBokinWIcrTjXVeOq";
//    String appSecret = "PFp3PZeEJIIRTtHqyG6Hhp1pyiS0ETjsb30XZVVhwR2n4WYQF4aI9A7EzUCrPsML";

    private final NumPersonMapper numPersonMapper;

    private final INpCommitService npCommitService;

    private final NpCommitTrainMapper npCommitTrainMapper;

    private final NpMusicMapper npMusicMapper;

//    private final NpTextMapper npTextMapper;

    private INpCommitService commitService;

    private final NpMaterialMapper materialMapper;

    private final NpTemplateDraftMapper npTemplateDraftMapper;

    private final NpVideoDraftMapper videoDraftMapper;

    @Autowired
    public void NpCommitServiceImpl(@Lazy INpCommitService commitService) {
        this.commitService = commitService;
    }

    /**
     * 3.2 定制模特列表查询
     */
    public void getCustomModelList(){
        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        // /openapi/robot/v2/pageList?access_token=55d1bc37-f960-4a9d-8c7d-5dc8c991c245
        String url = baseUrl + "/openapi/robot/v2/pageList?access_token=" + accessToken;

        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type","application/json;charset=UTF-8");

        JSONObject jsonParam = new JSONObject();
        jsonParam.put("page", "1");
        jsonParam.put("size", "10");
        jsonParam.put("myself", "true");
        //构造实体对象
        HttpEntity<JSONObject> param = new HttpEntity<>(jsonParam, headers);
        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.postForObject(url, param, JSONObject.class);

        log.info("3.2 定制模特列表查询 返回报文"+returnDataJSON.toJSONString());
        if ("0".equals(returnDataJSON.getString("code"))) {
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            //TODO
            dataJSON.getInteger("records");
            LinkedHashMap dataLinkMap = returnDataJSON.getObject("data", java.util.LinkedHashMap.class);
            System.out.println(dataLinkMap);
//            (ArrayList)dataLinkMap.get("records");
        }
    }

    /**
     * 3.3 免费模特列表查询(支持分页，推荐使用)
     */
    public void freeModelListQuery(){
        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        String url = baseUrl + "/openapi/robot/v2/freeListPage?access_token=" + accessToken;

        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type","application/json;charset=UTF-8");

        JSONObject jsonParam = new JSONObject();
        jsonParam.put("page", "1");
        jsonParam.put("size", "100");
        //构造实体对象
        HttpEntity<JSONObject> param = new HttpEntity<>(jsonParam, headers);
        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.postForObject(url, param, JSONObject.class);

        log.info("3.3 免费模特列表查询(支持分页，推荐使用) 返回报文"+returnDataJSON.toJSONString());
        if ("0".equals(returnDataJSON.getString("code"))) {
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            ArrayList records = dataJSON.getObject("records", ArrayList.class);
            for (int i = 0; i < records.size(); i++) {
                LinkedHashMap map = (LinkedHashMap)records.get(i);
                Object id = map.get("id");
                Object robotName = map.get("robotName");
                Object robotDesc = map.get("robotDesc");
                Object coverUrl = map.get("coverUrl");

            }
        }
    }


    /**
      * 3.5 企业所有发音人列表
     */
    public void allShoudList(){
        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        // /openapi/robot/v2/freeListPage?access_token=55d1bc37-f960-4a9d-8c7d-5dc8c991c245
        String url = baseUrl + "/openapi/speaker/v2/list?access_token=" + accessToken;
        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.getForObject(url, JSONObject.class);

        log.info("3.5 企业所有发音人列表 返回报文"+returnDataJSON.toJSONString());
        if ("0".equals(returnDataJSON.getString("code"))) {
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            ArrayList records = dataJSON.getObject("records", ArrayList.class);
            for (int i = 0; i < records.size(); i++) {
                LinkedHashMap map = (LinkedHashMap)records.get(i);
                Object id = map.get("id");
                Object robotName = map.get("robotName");
                Object robotDesc = map.get("robotDesc");
                Object coverUrl = map.get("coverUrl");

            }
        }
    }


    /**
     * 3.18 训练任务信息查询
     */
    public void queryTrainTask(){
        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        String url = baseUrl + "/openapi/video/v2/training/get/387?access_token=" + accessToken;

        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.getForObject(url, JSONObject.class);
        log.info(returnDataJSON.toJSONString());
        if ("0".equals(returnDataJSON.getString("code"))) {
            System.out.println(returnDataJSON.getString("message"));
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            //TODO
            dataJSON.getInteger("records");
        }
    }


    /**
     * 视频合成——3.17 训练任务列表查询
     * @param id
     */
    @Override
    public NpCommitTrain queryTrainVideoById(String id) {

        NpCommitTrain npCommitTrain = npCommitTrainMapper.selectById(id);
//        2训练成功 3训练失败 4审核不通过
//        status 训练状态 0或空-准备中 1训练中 2训练成功 3训练失败 4审核不通过
//        callbackStatus 回调状态 0或空-初始态 1-回调成功 2-回调失败
        if (null == npCommitTrain) {
            throw new ServerException(ErrorCode.NUMERSON_NO_NUMPERSON);
        }
        Integer status = npCommitTrain.getStatus();
        if (2 == status || 3 == status || 4 == status) {
            return  npCommitTrain;
        }

        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        String url = baseUrl + "/openapi/video/v2/training/get/"+npCommitTrain.getModelId()+"?access_token=" + accessToken;

        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.getForObject(url, JSONObject.class);
        log.info(returnDataJSON.toJSONString());
        if ("0".equals(returnDataJSON.getString("code"))) {
            System.out.println(returnDataJSON.getString("message"));
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            if(returnDataJSON.getBoolean("success")){}
            Integer rId = dataJSON.getInteger("id");
            String title = dataJSON.getString("title");
            String videoUrl = dataJSON.getString("videoUrl");
            Integer rStatus = dataJSON.getInteger("status");
            Integer callbackStatus = dataJSON.getInteger("callbackStatus");
            Integer robotId = dataJSON.getInteger("robotId");
            Integer sceneId = dataJSON.getInteger("sceneId");
            String coverUrl = dataJSON.getString("coverUrl");
            String createTime = dataJSON.getString("createTime");
            String updateTime = dataJSON.getString("updateTime");
            Object robot = dataJSON.get("robot");

            npCommitTrain.setTitle(title);
        }

        return null;
    }


    @Override
    public Page<NpSound> queryCompanySound(Integer type, String name, Integer pageNum, Integer size){
        if (type == null) {

        }
        if (pageNum == null || pageNum == 0) {
            pageNum = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }
        Page<NpSound> npSoundList = null;
        Page<NpSound> page = new Page<>(pageNum, size);
        if (!Strings.isBlank(name)) {
            npSoundList = numPersonMapper.queryCompanySound(SecurityUser.getUserId(), type, name, page);
            return npSoundList;
        }
        if (1 == type) {
            npSoundList = numPersonMapper.queryCompanySound(null, type, null, page);
        }
        if (2 == type) {
            Long baseUserId = SecurityUser.getUserId();
            npSoundList = numPersonMapper.queryCompanySound(baseUserId, type,null, page);
        }
        return npSoundList;
    }

    @Override
    public Page<NpFormwork> getCommonTemplate(Integer type, Integer pageNum, Integer size) {
        if (type == null) {

        }
        if (pageNum == null || pageNum == 0) {
            pageNum = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }
        Page<NpFormwork> formworkPage = null;
        Page<NpFormwork> page = new Page<>(pageNum, size);
//        if (1 == type) {
            formworkPage = npTemplateDraftMapper.getCommonTemplate(null, type, page);
//        }
//        if (2 == type) {
//            Long baseUserId = SecurityUser.getUserId();
//            formworkPage = npTemplateDraftMapper.getCommonTemplate(baseUserId, type, page);
//        }
        return formworkPage;
    }

    @Override
    public Page<NpTemplateDraft> sortDraftByUpdate(Integer pageNum, Integer size) {
//        if (type == null) {
//
//        }
        if (pageNum == null || pageNum == 0) {
            pageNum = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }
        Page<NpTemplateDraft> templateDraftPage = null;
        Page<NpTemplateDraft> page = new Page<>(pageNum, size);
//        if (1 == type) {
        templateDraftPage = npTemplateDraftMapper.sortDraftByUpdate(SecurityUser.getUserId(), page);
//        }
//        if (2 == type) {
//            Long baseUserId = SecurityUser.getUserId();
//            formworkPage = npTemplateDraftMapper.getCommonTemplate(baseUserId, type, page);
//        }
        return templateDraftPage;
    }

    @Override
    public List<NpTemplate> queryCommonTemplate(Integer page, Integer size) {
        if (page == null || page == 0) {
            page = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }
        int start = page*size - size;
//        int end = page * size;
        List<NpTemplate> npTemplateList = numPersonMapper.queryCommonTemplate(start, size);
        //        List<NpCommitTrain> npCommitTrains = npCommitTrainMapper.selectList(new QueryWrapper<NpCommitTrain>().eq("base_user_id", baseUserId).eq("status", "2").last("limit " + start + "," + end)
//                .select("id, cover_url, scene_id, title"));
        return npTemplateList;
    }

    @Override
    public Page<NpCommitTrain> queryTrainingModel(Integer type, String name, Integer pageNum, Integer size) {
        if (pageNum == null || pageNum == 0) {
            pageNum = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }

    Page<NpCommitTrain> page = new Page<>(pageNum, size);

    Page<NpCommitTrain> npCommitTrainPage = null;
    // 根据查询名称
    if (!Strings.isBlank(name)) {
        npCommitTrainPage = npCommitTrainMapper.queryCommitTrain(SecurityUser.getUserId(), type, name, page);
        return npCommitTrainPage;
    }

    if (type == 1) {
        npCommitTrainPage = npCommitTrainMapper.queryCommitTrain(null, type, null, page);
    } else {
        npCommitTrainPage = npCommitTrainMapper.queryCommitTrain(SecurityUser.getUserId(), type, null, page);
    }
    return npCommitTrainPage;
    }


    @Override
    public NpTemplateDraft getTemplateDraft(String templateId) {
        if (Strings.isBlank(templateId)) {
            NpTemplateDraft npTemplateDraft = new NpTemplateDraft();
            NpFormwork templateDraft = npTemplateDraftMapper.getTemplateDraft("1");
            npTemplateDraft.setNodes(templateDraft.getNodes());
            // 生成id
            SnowflakeIdWorker idGenerator = new SnowflakeIdWorker(1, 1);
            npTemplateDraft.setId(idGenerator.generateId());
            npTemplateDraft.setBaseUserId(SecurityUser.getUserId());
            String yyyyMMddHHmmss = DateUtil.format(new Date(), "yyyyMMddHHmmss");
            npTemplateDraft.setDraftName("未命名-" + yyyyMMddHHmmss);
            npTemplateDraftMapper.insert(npTemplateDraft);
//            log.info("插入成功");
            return npTemplateDraft;
        }
        // 查询草稿
        NpTemplateDraft npTemplateDraft = npTemplateDraftMapper.selectOne(new QueryWrapper<NpTemplateDraft>().eq("id", templateId));
        return npTemplateDraft;
    }

//    public List<NpCommitTrain> queryTrainingModel() {
////        // TODO 必须再加上baseuserId
////        Long baseUserId = SecurityUser.getUserId();
////        List<NpMaterial> npMaterials = materialMapper.selectList(new QueryWrapper<NpMaterial>().eq("base_user_id", baseUserId)
////                .eq("material_type", rootId).eq("del_flag", "0").last("limit " + start + "," + end)
////                .select("material_id, url, description, background_name"));
//        List<NpCommitTrain> npCommitTrains = npCommitTrainMapper.selectList(new QueryWrapper<NpCommitTrain>().eq("base_user_id", SecurityUser.getUserId()).eq("status", "2")
//                .select("model_id, video_url,title, cover_url, scene_id, robot_json"));
//        return npCommitTrains;
//    }

    /**
     * 训练数字人的查询
     */
    @Override
    public List<NpCommitTrain> queryTrainVideo(Integer page, Integer size) {
        if (page == null || page == 0) {
            page = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }
        int start = page*size - size;
//        int end = page * size;
        Long baseUserId = SecurityUser.getUserId();
        List<NpCommitTrain> npCommitTrains = npCommitTrainMapper.selectList(new QueryWrapper<NpCommitTrain>().eq("base_user_id", baseUserId).eq("status", "2").last("limit " + start + "," + size)
                .select("id, cover_url, scene_id, title"));
        return npCommitTrains;
    }

    @Override
    public List<NpMusic> queryMusic(NpMusic npMusic) {
        List<NpMusic> npMusics = npMusicMapper.queryMusic(SecurityUser.getUserId(), npMusic);
        return npMusics;
    }

//    @Override
//    public List<NpText> queryNpText(NpText npText) {
//        List<NpText> npTextList = npTextMapper.queryText(npText);
//        return npTextList;
//    }


    /**
     * 查询素材
     * @param rootId
     * @param page
     * @param size
     * @return
     */
    @Override
    public List<NpMaterial> queryMaterial(String rootId, Integer page, Integer size) {
        if (null == rootId) {
            log.error("请输入素材类型");
            throw new ServerException(ErrorCode.NUMERSON_NO_TYPE);
        }
        if (page == null || page == 0) {
            page = 1;
        }
        if (size == null || size < 0) {
            size = 10;
        }
        int start = page*size - size;
//        int end = page*size;
        Long baseUserId = SecurityUser.getUserId();
        List<NpMaterial> npMaterials = materialMapper.selectList(new QueryWrapper<NpMaterial>().eq("base_user_id", baseUserId)
                .eq("material_type", rootId).eq("del_flag", "0").last("limit " + start + "," + size)
                .select("material_id, url, description, background_name"));
        return npMaterials;
    }

    /**
     * 3.9 查询合成视频作品列表
     */
    public void getVideoList(){

        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        // /openapi/video/v2/pageList?access_token=55d1bc37-f960-4a9d-8c7d-5dc8c991c245
        String url = baseUrl + "/openapi/video/v2/pageList?access_token=" + accessToken;
        log.info("3.9 查询合成视频作品列表 请求地址："+url);

        JSONObject jsonParam = new JSONObject();
        jsonParam.put("page", "1");
        jsonParam.put("size", "100");
        HttpEntity param = new HttpEntity(jsonParam, new HttpHeaders());
        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.postForObject(url, param, JSONObject.class);

        log.info("3.9 查询合成视频作品列表 返回报文"+returnDataJSON.toJSONString());
        if ("0".equals(returnDataJSON.getString("code"))) {
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            //TODO
        }
    }

    /**
     * 3.19 合成任务信息查询
     */
    public void querySynthesisTask(){
        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        // /openapi/video/v2/get/{id}
        String url = baseUrl + "/openapi/video/v2/get/1?access_token=" + accessToken;
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type","application/json;charset=UTF-8");

        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.getForObject(url, JSONObject.class);
        if ("0".equals(returnDataJSON.getString("code"))) {
            System.out.println(returnDataJSON.getString("message"));
            JSONObject dataJSON = returnDataJSON.getJSONObject("data");
            System.out.println(dataJSON);
            //TODO
            dataJSON.getInteger("records");
        }
    }

    /**
     * 3.21 调用三方平台素材查询接口
     */
    @Override
    public JSONObject queryOpenAPIMaterial(Integer rootId, Integer page, Integer size) {
        if(rootId == null) {// 素材类型 ，0：背景（图片或者视频），1：图片素材，4：视频素材
            log.error("rootId为空");throw new ServerException(ErrorCode.NUMERSON_NO_ID);
        }
        if(!Arrays.asList(0, 1, 4).contains(rootId)) {
            throw new ServerException(ErrorCode.NUMERSON_NO_RIGHT_ID);
        }
        String accessToken = "";
        try {
            accessToken = npCommitService.getToken();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
        String url = baseUrl + "/openapi/material/search?access_token=" + accessToken;
        JSONObject jsonParam = new JSONObject();
        if(page == null) {
            jsonParam.put("page", 1);
        }else {
            jsonParam.put("page", page);
        }
        if(size == null) {
            jsonParam.put("size", 10);
        }else{
            jsonParam.put("size", size);
        }
        jsonParam.put("asc", "false");
        jsonParam.put("rootId", rootId);
//        jsonParam.put("myself", "true"); // 是否是自己上传的
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type","application/json;charset=UTF-8");
        //构造实体对象
        HttpEntity<JSONObject> param = new HttpEntity<>(jsonParam, headers);
        RestTemplate restTemplate = new RestTemplate();
        JSONObject returnDataJSON = restTemplate.postForObject(url, param, JSONObject.class);
//        System.out.println(returnDataJSON);
//        if ("0".equals(returnDataJSON.getString("code"))) {
//            LinkedHashMap data = (LinkedHashMap) returnDataJSON.get("data");
//            ArrayList records = (ArrayList)data.get("records");
//            for (int i = 0; i < records.size(); i++) {
//                LinkedHashMap record = (LinkedHashMap) records.get(i);
//            }
//        }
        return returnDataJSON;
    }
}
